Index: src/SynTree/Statement.h
===================================================================
--- src/SynTree/Statement.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Statement.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -38,5 +38,4 @@
 
 	Statement( const std::list<Label> & labels = {} );
-	virtual ~Statement();
 
 	std::list<Label> & get_labels() { return labels; }
@@ -56,5 +55,4 @@
 	CompoundStmt( std::list<Statement *> stmts );
 	CompoundStmt( const CompoundStmt &other );
-	virtual ~CompoundStmt();
 
 	std::list<Statement*>& get_kids() { return kids; }
@@ -84,5 +82,4 @@
 	ExprStmt( Expression *expr );
 	ExprStmt( const ExprStmt &other );
-	virtual ~ExprStmt();
 
 	Expression *get_expr() { return expr; }
@@ -105,5 +102,4 @@
 	AsmStmt( bool voltile, Expression *instruction, std::list<Expression *> output, std::list<Expression *> input, std::list<ConstantExpr *> clobber, std::list<Label> gotolabels );
 	AsmStmt( const AsmStmt &other );
-	virtual ~AsmStmt();
 
 	bool get_voltile() { return voltile; }
@@ -136,5 +132,4 @@
 			std::list<Statement *> initialization = std::list<Statement *>() );
 	IfStmt( const IfStmt &other );
-	virtual ~IfStmt();
 
 	std::list<Statement *> &get_initialization() { return initialization; }
@@ -159,5 +154,4 @@
 	SwitchStmt( Expression *condition, const std::list<Statement *> &statements );
 	SwitchStmt( const SwitchStmt &other );
-	virtual ~SwitchStmt();
 
 	Expression *get_condition() { return condition; }
@@ -181,5 +175,4 @@
 	CaseStmt( Expression *conditions, const std::list<Statement *> &stmts, bool isdef = false ) throw (SemanticErrorException);
 	CaseStmt( const CaseStmt &other );
-	virtual ~CaseStmt();
 
 	static CaseStmt * makeDefault( const std::list<Label> & labels = {}, std::list<Statement *> stmts = std::list<Statement *>() );
@@ -212,5 +205,4 @@
 	       Statement *body, bool isDoWhile = false );
 	WhileStmt( const WhileStmt &other );
-	virtual ~WhileStmt();
 
 	Expression *get_condition() { return condition; }
@@ -237,5 +229,4 @@
 	     Expression *condition = 0, Expression *increment = 0, Statement *body = 0 );
 	ForStmt( const ForStmt &other );
-	virtual ~ForStmt();
 
 	std::list<Statement *> &get_initialization() { return initialization; }
@@ -290,5 +281,4 @@
 	ReturnStmt( Expression *expr );
 	ReturnStmt( const ReturnStmt &other );
-	virtual ~ReturnStmt();
 
 	Expression *get_expr() { return expr; }
@@ -311,5 +301,4 @@
 	ThrowStmt( Kind kind, Expression * expr, Expression * target = nullptr );
 	ThrowStmt( const ThrowStmt &other );
-	virtual ~ThrowStmt();
 
 	Kind get_kind() { return kind; }
@@ -333,5 +322,4 @@
 	TryStmt( CompoundStmt *tryBlock, std::list<CatchStmt *> &handlers, FinallyStmt *finallyBlock = 0 );
 	TryStmt( const TryStmt &other );
-	virtual ~TryStmt();
 
 	CompoundStmt *get_block() const { return block; }
@@ -360,5 +348,4 @@
 	           Expression *cond, Statement *body );
 	CatchStmt( const CatchStmt &other );
-	virtual ~CatchStmt();
 
 	Kind get_kind() { return kind; }
@@ -382,5 +369,4 @@
 	FinallyStmt( CompoundStmt *block );
 	FinallyStmt( const FinallyStmt &other );
-	virtual ~FinallyStmt();
 
 	CompoundStmt *get_block() const { return block; }
@@ -409,5 +395,4 @@
 	WaitForStmt();
 	WaitForStmt( const WaitForStmt & );
-	virtual ~WaitForStmt();
 
 	std::vector<Clause> clauses;
@@ -438,5 +423,4 @@
 	WithStmt( const std::list< Expression * > & exprs, Statement * stmt );
 	WithStmt( const WithStmt & other );
-	virtual ~WithStmt();
 
 	virtual WithStmt * clone() const override { return new WithStmt( *this ); }
@@ -454,5 +438,4 @@
 	DeclStmt( Declaration *decl );
 	DeclStmt( const DeclStmt &other );
-	virtual ~DeclStmt();
 
 	Declaration *get_decl() const { return decl; }
@@ -476,5 +459,4 @@
 	ImplicitCtorDtorStmt( Statement * callStmt );
 	ImplicitCtorDtorStmt( const ImplicitCtorDtorStmt & other );
-	virtual ~ImplicitCtorDtorStmt();
 
 	Statement *get_callStmt() const { return callStmt; }
Index: src/SynTree/TupleExpr.cc
===================================================================
--- src/SynTree/TupleExpr.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TupleExpr.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -35,8 +35,4 @@
 }
 
-UntypedTupleExpr::~UntypedTupleExpr() {
-	deleteAll( exprs );
-}
-
 void UntypedTupleExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Untyped Tuple:" << std::endl;
@@ -51,8 +47,4 @@
 TupleExpr::TupleExpr( const TupleExpr &other ) : Expression( other ) {
 	cloneAll( other.exprs, exprs );
-}
-
-TupleExpr::~TupleExpr() {
-	deleteAll( exprs );
 }
 
@@ -72,8 +64,4 @@
 
 TupleIndexExpr::TupleIndexExpr( const TupleIndexExpr &other ) : Expression( other ), tuple( other.tuple->clone() ), index( other.index ) {
-}
-
-TupleIndexExpr::~TupleIndexExpr() {
-	delete tuple;
 }
 
@@ -105,8 +93,4 @@
 }
 
-TupleAssignExpr::~TupleAssignExpr() {
-	delete stmtExpr;
-}
-
 void TupleAssignExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Tuple Assignment Expression, with stmt expr:" << std::endl;
Index: src/SynTree/TupleType.cc
===================================================================
--- src/SynTree/TupleType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TupleType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -43,9 +43,4 @@
 }
 
-TupleType::~TupleType() {
-	deleteAll( types );
-	deleteAll( members );
-}
-
 void TupleType::print( std::ostream &os, Indenter indent ) const {
 	Type::print( os, indent );
Index: src/SynTree/Type.cc
===================================================================
--- src/SynTree/Type.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Type.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -57,9 +57,4 @@
 }
 
-Type::~Type() {
-	deleteAll( forall );
-	deleteAll( attributes );
-}
-
 // These must remain in the same order as the corresponding bit fields.
 const char * Type::FuncSpecifiersNames[] = { "inline", "fortran", "_Noreturn" };
Index: src/SynTree/Type.h
===================================================================
--- src/SynTree/Type.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Type.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -141,5 +141,4 @@
 	Type( const Qualifiers & tq, const std::list< Attribute * > & attributes );
 	Type( const Type & other );
-	virtual ~Type();
 
 	Qualifiers & get_qualifiers() { return tq; }
@@ -261,5 +260,4 @@
 	PointerType( const Type::Qualifiers & tq, Type *base, Expression *dimension, bool isVarLen, bool isStatic, const std::list< Attribute * > & attributes = std::list< Attribute * >() );
 	PointerType( const PointerType& );
-	virtual ~PointerType();
 
 	Type *get_base() { return base; }
@@ -291,5 +289,4 @@
 	ArrayType( const Type::Qualifiers & tq, Type *base, Expression *dimension, bool isVarLen, bool isStatic, const std::list< Attribute * > & attributes = std::list< Attribute * >() );
 	ArrayType( const ArrayType& );
-	virtual ~ArrayType();
 
 	Type *get_base() { return base; }
@@ -319,5 +316,4 @@
 	ReferenceType( const Type::Qualifiers & tq, Type *base, const std::list< Attribute * > & attributes = std::list< Attribute * >() );
 	ReferenceType( const ReferenceType & );
-	virtual ~ReferenceType();
 
 	Type *get_base() { return base; }
@@ -352,5 +348,4 @@
 	FunctionType( const Type::Qualifiers & tq, bool isVarArgs, const std::list< Attribute * > & attributes = std::list< Attribute * >() );
 	FunctionType( const FunctionType& );
-	virtual ~FunctionType();
 
 	std::list<DeclarationWithType*> & get_returnVals() { return returnVals; }
@@ -376,5 +371,4 @@
 	ReferenceToType( const Type::Qualifiers & tq, const std::string & name, const std::list< Attribute * > & attributes );
 	ReferenceToType( const ReferenceToType & other );
-	virtual ~ReferenceToType();
 
 	const std::string & get_name() const { return name; }
@@ -503,5 +497,4 @@
 	TraitInstType( const Type::Qualifiers & tq, TraitDecl * baseTrait, const std::list< Attribute * > & attributes = std::list< Attribute * >() );
 	TraitInstType( const TraitInstType & other );
-	~TraitInstType();
 
 	virtual bool isComplete() const override;
@@ -525,5 +518,4 @@
 	TypeInstType( const Type::Qualifiers & tq, const std::string & name, bool isFtype, const std::list< Attribute * > & attributes = std::list< Attribute * >()  );
 	TypeInstType( const TypeInstType & other );
-	~TypeInstType();
 
 	TypeDecl *get_baseType() const { return baseType; }
@@ -549,5 +541,4 @@
 	TupleType( const Type::Qualifiers & tq, const std::list< Type * > & types, const std::list< Attribute * > & attributes = std::list< Attribute * >()  );
 	TupleType( const TupleType& );
-	virtual ~TupleType();
 
 	typedef std::list<Type*> value_type;
@@ -583,5 +574,4 @@
 	TypeofType( const Type::Qualifiers & tq, Expression *expr, const std::list< Attribute * > & attributes = std::list< Attribute * >()  );
 	TypeofType( const TypeofType& );
-	virtual ~TypeofType();
 
 	Expression *get_expr() const { return expr; }
@@ -606,5 +596,4 @@
 	AttrType( const Type::Qualifiers & tq, const std::string & name, Type *type, const std::list< Attribute * > & attributes = std::list< Attribute * >()  );
 	AttrType( const AttrType& );
-	virtual ~AttrType();
 
 	const std::string & get_name() const { return name; }
Index: src/SynTree/TypeDecl.cc
===================================================================
--- src/SynTree/TypeDecl.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TypeDecl.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -25,8 +25,4 @@
 
 TypeDecl::TypeDecl( const TypeDecl &other ) : Parent( other ), init( maybeClone( other.init ) ), sized( other.sized ), kind( other.kind ) {
-}
-
-TypeDecl::~TypeDecl() {
-  delete init;
 }
 
Index: src/SynTree/TypeExpr.cc
===================================================================
--- src/SynTree/TypeExpr.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TypeExpr.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -26,8 +26,4 @@
 }
 
-TypeExpr::~TypeExpr() {
-	delete type;
-}
-
 void TypeExpr::print( std::ostream &os, Indenter indent ) const {
 	if ( type ) type->print( os, indent );
Index: src/SynTree/TypeSubstitution.cc
===================================================================
--- src/SynTree/TypeSubstitution.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TypeSubstitution.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -26,13 +26,4 @@
 }
 
-TypeSubstitution::~TypeSubstitution() {
-	for ( TypeEnvType::iterator i = typeEnv.begin(); i != typeEnv.end(); ++i ) {
-		delete( i->second );
-	}
-	for ( VarEnvType::iterator i = varEnv.begin(); i != varEnv.end(); ++i ) {
-		delete( i->second );
-	}
-}
-
 TypeSubstitution &TypeSubstitution::operator=( const TypeSubstitution &other ) {
 	if ( this == &other ) return *this;
@@ -57,17 +48,9 @@
 
 void TypeSubstitution::add( std::string formalType, Type *actualType ) {
-	TypeEnvType::iterator i = typeEnv.find( formalType );
-	if ( i != typeEnv.end() ) {
-		delete i->second;
-	} // if
 	typeEnv[ formalType ] = actualType->clone();
 }
 
 void TypeSubstitution::remove( std::string formalType ) {
-	TypeEnvType::iterator i = typeEnv.find( formalType );
-	if ( i != typeEnv.end() ) {
-		delete i->second;
-		typeEnv.erase( formalType );
-	} // if
+	typeEnv.erase( formalType );
 }
 
@@ -155,5 +138,4 @@
 		Type * newtype = i->second->clone();
 		newtype->get_qualifiers() |= inst->get_qualifiers();
-		delete inst;
 		return newtype;
 	} // if
@@ -166,5 +148,4 @@
 	} else {
 		subCount++;
-		delete nameExpr;
 		return i->second->clone();
 	} // if
Index: src/SynTree/TypeSubstitution.h
===================================================================
--- src/SynTree/TypeSubstitution.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TypeSubstitution.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -35,5 +35,4 @@
 	TypeSubstitution( FormalIterator formalBegin, FormalIterator formalEnd, ActualIterator actualBegin );
 	TypeSubstitution( const TypeSubstitution &other );
-	virtual ~TypeSubstitution();
 
 	TypeSubstitution &operator=( const TypeSubstitution &other );
@@ -101,8 +100,4 @@
 			if ( TypeExpr *actual = dynamic_cast< TypeExpr* >( *actualIt ) ) {
 				if ( formal->get_name() != "" ) {
-					TypeEnvType::iterator i = typeEnv.find( formal->get_name() );
-					if ( i != typeEnv.end() ) {
-						delete i->second;
-					} // if
 					typeEnv[ formal->get_name() ] = actual->get_type()->clone();
 				} // if
Index: src/SynTree/TypeofType.cc
===================================================================
--- src/SynTree/TypeofType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/TypeofType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -29,8 +29,4 @@
 }
 
-TypeofType::~TypeofType() {
-	delete expr;
-}
-
 void TypeofType::print( std::ostream &os, Indenter indent ) const {
 	Type::print( os, indent );
Index: src/SynTree/module.mk
===================================================================
--- src/SynTree/module.mk	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/module.mk	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -48,4 +48,5 @@
        SynTree/TypeSubstitution.cc \
        SynTree/Attribute.cc \
+       SynTree/GcTracer.cc \
        SynTree/VarExprReplacer.cc
 
Index: src/Tuples/Explode.cc
===================================================================
--- src/Tuples/Explode.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Tuples/Explode.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -70,6 +70,5 @@
 				// should now be a tuple of references rather than a reference to a tuple.
 				// Still, this code is a bit awkward, and could use some improvement.
-				UniqueExpr * newUniqueExpr = new UniqueExpr( applyCast( uniqueExpr->get_expr() ), uniqueExpr->get_id() );
-				delete uniqueExpr;
+				UniqueExpr * newUniqueExpr = new UniqueExpr{ applyCast( uniqueExpr->get_expr() ), uniqueExpr->get_id() };
 				if ( castAdded ) {
 					// if a cast was added by applyCast, then unique expr now has one more layer of reference
@@ -88,9 +87,5 @@
 				// field is consistent with the type of the tuple expr, since the field
 				// may have changed from type T to T&.
-				Expression * expr = tupleExpr->get_tuple();
-				tupleExpr->set_tuple( nullptr );
-				TupleIndexExpr * ret = new TupleIndexExpr( expr, tupleExpr->get_index() );
-				delete tupleExpr;
-				return ret;
+				return new TupleIndexExpr{ tupleExpr->get_tuple(), tupleExpr->get_index() };
 			}
 		};
Index: src/Tuples/Explode.h
===================================================================
--- src/Tuples/Explode.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Tuples/Explode.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -27,5 +27,5 @@
 namespace SymTab {
 class Indexer;
-}  // namespace SymTab
+}  // namespace SymTabf
 
 namespace Tuples {
@@ -67,5 +67,5 @@
 				for ( ResolvExpr::Alternative & alt : alts ) {
 					// distribute reference cast over all components
-					append( std::forward<Output>(out), distributeReference( alt.release_expr() ),
+					append( std::forward<Output>(out), distributeReference( alt.expr ),
 						alt.env, alt.cost, alt.cvtCost );
 				}
@@ -96,7 +96,5 @@
 					TupleIndexExpr * idx = new TupleIndexExpr( arg->clone(), i );
 					explodeUnique( idx, alt, indexer, std::forward<Output>(out), isTupleAssign );
-					delete idx;
 				}
-				delete arg;
 			}
 		} else {
Index: src/Tuples/TupleExpansion.cc
===================================================================
--- src/Tuples/TupleExpansion.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Tuples/TupleExpansion.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -45,10 +45,4 @@
 
 			std::map< int, Expression * > decls; // not vector, because order added may not be increasing order
-
-			~UniqueExprExpander() {
-				for ( std::pair<const int, Expression *> & p : decls ) {
-					delete p.second;
-				}
-			}
 		};
 
@@ -111,7 +105,4 @@
 				UntypedMemberExpr * newMemberExpr = new UntypedMemberExpr( memberExpr->member, inner );
 				inner->location = newMemberExpr->location = loc;
-				memberExpr->member = nullptr;
-				memberExpr->aggregate = nullptr;
-				delete memberExpr;
 				return newMemberExpr->acceptMutator( expander );
 			} else {
@@ -135,5 +126,4 @@
 				expr->location = memberExpr->location;
 			}
-			delete aggr;
 			tupleExpr->location = memberExpr->location;
 			return tupleExpr;
@@ -181,5 +171,4 @@
 			decls[id] = condExpr;
 		}
-		delete unqExpr;
 		return decls[id]->clone();
 	}
@@ -191,5 +180,4 @@
 		ret->set_env( assnExpr->get_env() );
 		assnExpr->set_env( nullptr );
-		delete assnExpr;
 		return ret;
 	}
@@ -222,5 +210,4 @@
 			newType->get_parameters().push_back( new TypeExpr( t->clone() ) );
 		}
-		delete tupleType;
 		return newType;
 	}
@@ -233,5 +220,4 @@
 		TypeSubstitution * env = tupleExpr->get_env();
 		tupleExpr->set_env( nullptr );
-		delete tupleExpr;
 
 		StructInstType * type = strict_dynamic_cast< StructInstType * >( tuple->get_result() );
@@ -275,9 +261,6 @@
 		TypeSubstitution * env = tupleExpr->get_env();
 
-		// remove data from shell and delete it
-		tupleExpr->set_result( nullptr );
-		tupleExpr->get_exprs().clear();
+		// remove data from shell
 		tupleExpr->set_env( nullptr );
-		delete tupleExpr;
 
 		return replaceTupleExpr( result, exprs, env );
Index: src/Virtual/ExpandCasts.cc
===================================================================
--- src/Virtual/ExpandCasts.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/Virtual/ExpandCasts.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -139,5 +139,5 @@
 		ObjectDecl * table = found->second;
 
-		Expression * result = new CastExpr(
+		return new CastExpr{
 			//new ApplicationExpr(
 				//new AddressExpr( new VariableExpr( vcast_decl ) ),
@@ -158,10 +158,5 @@
 				} ),
 			castExpr->get_result()->clone()
-			);
-
-		castExpr->set_arg( nullptr );
-		castExpr->set_result( nullptr );
-		delete castExpr;
-		return result;
+		};
 	}
 
Index: src/main.cc
===================================================================
--- src/main.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/main.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -37,4 +37,5 @@
 #include "Common/PassVisitor.h"
 #include "Common/CompilerError.h"           // for CompilerError
+#include "Common/GC.h"						// for GC
 #include "Common/SemanticError.h"           // for SemanticError
 #include "Common/UnimplementedError.h"      // for UnimplementedError
@@ -57,4 +58,5 @@
 #include "SymTab/Validate.h"                // for validate
 #include "SynTree/Declaration.h"            // for Declaration
+#include "SynTree/GcTracer.h"               // for GC << TranslationUnit
 #include "SynTree/Visitor.h"                // for acceptAll
 #include "Tuples/Tuples.h"                  // for expandMemberTuples, expan...
@@ -64,5 +66,4 @@
 
 #define OPTPRINT(x) if ( errorp ) cerr << x << endl;
-
 
 LinkageSpec::Spec linkage = LinkageSpec::Cforall;
@@ -233,4 +234,5 @@
 		delete parseTree;
 		parseTree = nullptr;
+		collect( translationUnit );
 
 		if ( astp ) {
@@ -242,8 +244,6 @@
 		OPTPRINT( "validate" )
 		SymTab::validate( translationUnit, symtabp );
-		if ( symtabp ) {
-			deleteAll( translationUnit );
-			return 0;
-		} // if
+		collect( translationUnit );
+		if ( symtabp ) return 0;
 
 		if ( expraltp ) {
@@ -266,4 +266,5 @@
 		OPTPRINT( "expandMemberTuples" );
 		Tuples::expandMemberTuples( translationUnit );
+		collect( translationUnit );
 		if ( libcfap ) {
 			// generate the bodies of cfa library functions
@@ -273,5 +274,4 @@
 		if ( declstatsp ) {
 			CodeTools::printDeclStats( translationUnit );
-			deleteAll( translationUnit );
 			return 0;
 		}
@@ -286,4 +286,5 @@
 		OPTPRINT( "resolve" )
 		ResolvExpr::resolve( translationUnit );
+		collect( translationUnit );
 		if ( exprp ) {
 			dump( translationUnit );
@@ -294,4 +295,5 @@
 		OPTPRINT( "fixInit" )
 		InitTweak::fix( translationUnit, filename, libcfap || treep );
+		collect( translationUnit );
 		if ( ctorinitp ) {
 			dump ( translationUnit );
@@ -313,4 +315,5 @@
 		OPTPRINT( "expandTuples" ); // xxx - is this the right place for this?
 		Tuples::expandTuples( translationUnit );
+		collect( translationUnit );
 		if ( tuplep ) {
 			dump( translationUnit );
@@ -323,19 +326,21 @@
 		OPTPRINT("instantiateGenerics")
 		GenPoly::instantiateGeneric( translationUnit );
+		collect( translationUnit );
 		if ( genericsp ) {
 			dump( translationUnit );
 			return 0;
 		}
+
 		OPTPRINT( "convertLvalue" )
 		GenPoly::convertLvalue( translationUnit );
-
-
+		collect( translationUnit );
 		if ( bboxp ) {
 			dump( translationUnit );
 			return 0;
 		} // if
+
 		OPTPRINT( "box" )
 		GenPoly::box( translationUnit );
-
+		collect( translationUnit );
 		if ( bcodegenp ) {
 			dump( translationUnit );
@@ -383,5 +388,4 @@
 	} // try
 
-	deleteAll( translationUnit );
 	return 0;
 } // main
@@ -568,5 +572,4 @@
 		printAll( decls, out );
 	}
-	deleteAll( translationUnit );
 } // dump
 
